package org.jboss.errai.ioc.client;

import java.lang.annotation.Annotation;
import javax.enterprise.context.Dependent;
import javax.enterprise.event.Event;
import org.dashbuilder.client.widgets.common.ClientRuntimeErrorPopupPresenter;
import org.guvnor.common.services.project.client.context.WorkspaceProjectContext;
import org.guvnor.common.services.project.client.security.ProjectController;
import org.guvnor.common.services.shared.metadata.model.Metadata;
import org.guvnor.messageconsole.client.console.widget.button.AlertsButtonMenuItemBuilder;
import org.guvnor.structure.repositories.RepositoryRemovedEvent;
import org.jboss.errai.bus.client.ErraiBus;
import org.jboss.errai.bus.client.api.Subscription;
import org.jboss.errai.common.client.api.Caller;
import org.jboss.errai.enterprise.client.cdi.AbstractCDIEventCallback;
import org.jboss.errai.enterprise.client.cdi.api.CDI;
import org.jboss.errai.ioc.client.api.ManagedInstance;
import org.jboss.errai.ioc.client.container.ContextManager;
import org.jboss.errai.ioc.client.container.Factory;
import org.jboss.errai.ioc.client.container.FactoryHandleImpl;
import org.kie.workbench.common.dmn.client.decision.DecisionNavigatorDock;
import org.kie.workbench.common.dmn.client.editors.documentation.DMNDocumentationView;
import org.kie.workbench.common.dmn.client.editors.included.IncludedModelsPage;
import org.kie.workbench.common.dmn.client.editors.included.imports.IncludedModelsPageStateProviderImpl;
import org.kie.workbench.common.dmn.client.editors.search.DMNEditorSearchIndex;
import org.kie.workbench.common.dmn.client.editors.search.DMNSearchableElement;
import org.kie.workbench.common.dmn.client.editors.types.DataTypePageTabActiveEvent;
import org.kie.workbench.common.dmn.client.editors.types.DataTypesPage;
import org.kie.workbench.common.dmn.client.editors.types.listview.common.DataTypeEditModeToggleEvent;
import org.kie.workbench.common.dmn.client.events.EditExpressionEvent;
import org.kie.workbench.common.dmn.project.client.editor.DMNDiagramEditor;
import org.kie.workbench.common.dmn.project.client.editor.DMNProjectEditorMenuSessionItems;
import org.kie.workbench.common.dmn.project.client.type.DMNDiagramResourceType;
import org.kie.workbench.common.stunner.client.widgets.presenters.session.impl.SessionEditorPresenter;
import org.kie.workbench.common.stunner.client.widgets.presenters.session.impl.SessionViewerPresenter;
import org.kie.workbench.common.stunner.core.client.annotation.DiagramEditor;
import org.kie.workbench.common.stunner.core.client.api.SessionManager;
import org.kie.workbench.common.stunner.core.client.api.SessionManagerImpl;
import org.kie.workbench.common.stunner.core.client.canvas.AbstractCanvasHandler;
import org.kie.workbench.common.stunner.core.client.command.SessionCommandManager;
import org.kie.workbench.common.stunner.core.client.command.SessionCommandManagerImpl;
import org.kie.workbench.common.stunner.core.client.components.layout.LayoutHelper;
import org.kie.workbench.common.stunner.core.client.components.layout.OpenDiagramLayoutExecutor;
import org.kie.workbench.common.stunner.core.client.error.DiagramClientErrorHandler;
import org.kie.workbench.common.stunner.core.client.i18n.ClientTranslationService;
import org.kie.workbench.common.stunner.core.client.session.event.OnSessionErrorEvent;
import org.kie.workbench.common.stunner.core.client.session.impl.EditorSession;
import org.kie.workbench.common.stunner.core.client.session.impl.ViewerSession;
import org.kie.workbench.common.stunner.core.documentation.DocumentationView;
import org.kie.workbench.common.stunner.forms.client.event.RefreshFormPropertiesEvent;
import org.kie.workbench.common.stunner.project.client.editor.AbstractProjectDiagramEditor;
import org.kie.workbench.common.stunner.project.client.editor.AbstractProjectDiagramEditor.View;
import org.kie.workbench.common.stunner.project.client.editor.ProjectDiagramEditorView;
import org.kie.workbench.common.stunner.project.client.editor.event.OnDiagramFocusEvent;
import org.kie.workbench.common.stunner.project.client.editor.event.OnDiagramLoseFocusEvent;
import org.kie.workbench.common.stunner.project.client.screens.ProjectMessagesListener;
import org.kie.workbench.common.stunner.project.client.service.ClientProjectDiagramService;
import org.kie.workbench.common.stunner.project.editor.ProjectDiagramResource;
import org.kie.workbench.common.stunner.project.service.ProjectDiagramResourceService;
import org.kie.workbench.common.widgets.client.docks.DefaultEditorDock;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilder;
import org.kie.workbench.common.widgets.client.menu.FileMenuBuilderImpl;
import org.kie.workbench.common.widgets.client.search.component.SearchBarComponent;
import org.kie.workbench.common.widgets.metadata.client.KieEditor;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperView;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperView.KieEditorWrapperPresenter;
import org.kie.workbench.common.widgets.metadata.client.KieEditorWrapperViewImpl;
import org.kie.workbench.common.widgets.metadata.client.validation.AssetUpdateValidator;
import org.kie.workbench.common.widgets.metadata.client.widget.OverviewWidgetPresenter;
import org.uberfire.client.mvp.PerspectiveManager;
import org.uberfire.client.mvp.PerspectiveManagerImpl;
import org.uberfire.client.mvp.PlaceManager;
import org.uberfire.client.mvp.PlaceManagerImpl;
import org.uberfire.client.promise.Promises;
import org.uberfire.client.views.pfly.multipage.MultiPageEditorSelectedPageEvent;
import org.uberfire.client.workbench.events.ChangeTitleWidgetEvent;
import org.uberfire.client.workbench.events.PlaceGainFocusEvent;
import org.uberfire.client.workbench.events.PlaceHiddenEvent;
import org.uberfire.client.workbench.widgets.common.ErrorPopupPresenter;
import org.uberfire.ext.editor.commons.client.BaseEditor;
import org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteAcceptedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentDeleteIgnoredEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentRenameAcceptedEvent;
import org.uberfire.ext.editor.commons.client.event.ConcurrentRenameIgnoredEvent;
import org.uberfire.ext.editor.commons.client.file.popups.CopyPopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.DeletePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.RenamePopUpPresenter;
import org.uberfire.ext.editor.commons.client.file.popups.SavePopUpPresenter;
import org.uberfire.ext.editor.commons.client.history.VersionRecordManager;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilder;
import org.uberfire.ext.editor.commons.client.menu.BasicFileMenuBuilderImpl;
import org.uberfire.ext.editor.commons.client.menu.DownloadMenuItemBuilder;
import org.uberfire.ext.editor.commons.client.menu.common.SaveAndRenameCommandBuilder;
import org.uberfire.ext.editor.commons.client.validation.DefaultFileNameValidator;
import org.uberfire.ext.editor.commons.version.events.RestoreEvent;
import org.uberfire.ext.widgets.core.client.editors.texteditor.TextEditorView;
import org.uberfire.workbench.events.NotificationEvent;

public class Type_factory__o_k_w_c_d_p_c_e_DMNDiagramEditor__quals__j_e_i_Any_o_k_w_c_s_c_c_a_DiagramEditor extends Factory<DMNDiagramEditor> { public Type_factory__o_k_w_c_d_p_c_e_DMNDiagramEditor__quals__j_e_i_Any_o_k_w_c_s_c_c_a_DiagramEditor() {
    super(new FactoryHandleImpl(DMNDiagramEditor.class, "Type_factory__o_k_w_c_d_p_c_e_DMNDiagramEditor__quals__j_e_i_Any_o_k_w_c_s_c_c_a_DiagramEditor", Dependent.class, false, null, true));
    handle.setAssignableTypes(new Class[] { DMNDiagramEditor.class, AbstractProjectDiagramEditor.class, KieEditor.class, BaseEditor.class, Object.class, KieEditorWrapperPresenter.class });
    handle.setQualifiers(new Annotation[] { QualifierUtil.ANY_ANNOTATION, new DiagramEditor() {
        public Class annotationType() {
          return DiagramEditor.class;
        }
        public String toString() {
          return "@org.kie.workbench.common.stunner.core.client.annotation.DiagramEditor()";
        }
    } });
  }

  public DMNDiagramEditor createInstance(final ContextManager contextManager) {
    final SavePopUpPresenter _savePopUpPresenter_5 = (SavePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_SavePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    final ManagedInstance<SessionEditorPresenter<EditorSession>> _editorSessionPresenterInstances_8 = (ManagedInstance) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal", new Class[] { SessionEditorPresenter.class }, new Annotation[] { });
    final TextEditorView _xmlEditorView_17 = (TextEditorView) contextManager.getInstance("Type_factory__o_u_e_w_c_c_e_t_TextEditorView__quals__j_e_i_Any_j_e_i_Default");
    final Event<RefreshFormPropertiesEvent> _refreshFormPropertiesEvent_13 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { RefreshFormPropertiesEvent.class }, new Annotation[] { });
    final PlaceManager _placeManager_2 = (PlaceManagerImpl) contextManager.getInstance("Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default");
    final DMNDiagramResourceType _resourceType_6 = (DMNDiagramResourceType) contextManager.getInstance("Type_factory__o_k_w_c_d_p_c_t_DMNDiagramResourceType__quals__j_e_i_Any_j_e_i_Default");
    final ClientProjectDiagramService _projectDiagramServices_7 = (ClientProjectDiagramService) contextManager.getInstance("Type_factory__o_k_w_c_s_p_c_s_ClientProjectDiagramService__quals__j_e_i_Any_j_e_i_Default");
    final SessionCommandManager<AbstractCanvasHandler> _sessionCommandManager_20 = (SessionCommandManagerImpl) contextManager.getInstance("Type_factory__o_k_w_c_s_c_c_c_SessionCommandManagerImpl__quals__j_e_i_Any_o_k_w_c_s_c_c_s_Session");
    final Event<ChangeTitleWidgetEvent> _changeTitleNotificationEvent_4 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ChangeTitleWidgetEvent.class }, new Annotation[] { });
    final IncludedModelsPage _includedModelsPage_25 = (IncludedModelsPage) contextManager.getInstance("Type_factory__o_k_w_c_d_c_e_i_IncludedModelsPage__quals__j_e_i_Any_j_e_i_Default");
    final Event<OnDiagramFocusEvent> _onDiagramFocusEvent_11 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { OnDiagramFocusEvent.class }, new Annotation[] { });
    final DMNProjectEditorMenuSessionItems _menuSessionItems_10 = (DMNProjectEditorMenuSessionItems) contextManager.getInstance("Type_factory__o_k_w_c_d_p_c_e_DMNProjectEditorMenuSessionItems__quals__j_e_i_Any_j_e_i_Default");
    final ErrorPopupPresenter _errorPopupPresenter_3 = (ClientRuntimeErrorPopupPresenter) contextManager.getInstance("Type_factory__o_d_c_w_c_ClientRuntimeErrorPopupPresenter__quals__j_e_i_Any_j_e_i_Default");
    final ManagedInstance<SessionViewerPresenter<ViewerSession>> _viewerSessionPresenterInstances_9 = (ManagedInstance) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal", new Class[] { SessionViewerPresenter.class }, new Annotation[] { });
    final SessionManager _sessionManager_19 = (SessionManagerImpl) contextManager.getInstance("Type_factory__o_k_w_c_s_c_c_a_SessionManagerImpl__quals__j_e_i_Any_j_e_i_Default");
    final ClientTranslationService _translationService_16 = (ClientTranslationService) contextManager.getInstance("Type_factory__o_k_w_c_s_c_c_i_ClientTranslationService__quals__j_e_i_Any_j_e_i_Default");
    final DiagramClientErrorHandler _diagramClientErrorHandler_15 = (DiagramClientErrorHandler) contextManager.getInstance("Type_factory__o_k_w_c_s_c_c_e_DiagramClientErrorHandler__quals__j_e_i_Any_j_e_i_Default");
    final DMNEditorSearchIndex _editorSearchIndex_27 = (DMNEditorSearchIndex) contextManager.getInstance("Type_factory__o_k_w_c_d_c_e_s_DMNEditorSearchIndex__quals__j_e_i_Any_j_e_i_Default");
    final LayoutHelper _layoutHelper_22 = (LayoutHelper) contextManager.getInstance("Type_factory__o_k_w_c_s_c_c_c_l_LayoutHelper__quals__j_e_i_Any_j_e_i_Default");
    final OpenDiagramLayoutExecutor _openDiagramLayoutExecutor_24 = (OpenDiagramLayoutExecutor) contextManager.getInstance("Type_factory__o_k_w_c_s_c_c_c_l_OpenDiagramLayoutExecutor__quals__j_e_i_Any_j_e_i_Default");
    final DecisionNavigatorDock _decisionNavigatorDock_21 = (DecisionNavigatorDock) contextManager.getInstance("Type_factory__o_k_w_c_d_c_d_DecisionNavigatorDock__quals__j_e_i_Any_j_e_i_Default");
    final Event<OnDiagramLoseFocusEvent> _onDiagramLostFocusEvent_12 = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { OnDiagramLoseFocusEvent.class }, new Annotation[] { });
    final DataTypesPage _dataTypesPage_23 = (DataTypesPage) contextManager.getInstance("Type_factory__o_k_w_c_d_c_e_t_DataTypesPage__quals__j_e_i_Any_j_e_i_Default");
    final DocumentationView _documentationView_1 = (DMNDocumentationView) contextManager.getInstance("Type_factory__o_k_w_c_d_c_e_d_DMNDocumentationView__quals__j_e_i_Any_o_k_w_c_d_a_q_DMNEditor");
    final Caller<ProjectDiagramResourceService> _projectDiagramResourceServiceCaller_18 = (Caller) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_c_c_a_Caller__quals__Universal", new Class[] { ProjectDiagramResourceService.class }, new Annotation[] { });
    final IncludedModelsPageStateProviderImpl _importsPageProvider_26 = (IncludedModelsPageStateProviderImpl) contextManager.getInstance("Type_factory__o_k_w_c_d_c_e_i_i_IncludedModelsPageStateProviderImpl__quals__j_e_i_Any_j_e_i_Default");
    final ProjectMessagesListener _projectMessagesListener_14 = (ProjectMessagesListener) contextManager.getInstance("Type_factory__o_k_w_c_s_p_c_s_ProjectMessagesListener__quals__j_e_i_Any_j_e_i_Default");
    final View _view_0 = (ProjectDiagramEditorView) contextManager.getInstance("Type_factory__o_k_w_c_s_p_c_e_ProjectDiagramEditorView__quals__j_e_i_Any_j_e_i_Default");
    final SearchBarComponent<DMNSearchableElement> _searchBarComponent_28 = (SearchBarComponent) contextManager.getInstance("Type_factory__o_k_w_c_w_c_s_c_SearchBarComponent__quals__j_e_i_Any_j_e_i_Default");
    final DMNDiagramEditor instance = new DMNDiagramEditor(_view_0, _documentationView_1, _placeManager_2, _errorPopupPresenter_3, _changeTitleNotificationEvent_4, _savePopUpPresenter_5, _resourceType_6, _projectDiagramServices_7, _editorSessionPresenterInstances_8, _viewerSessionPresenterInstances_9, _menuSessionItems_10, _onDiagramFocusEvent_11, _onDiagramLostFocusEvent_12, _refreshFormPropertiesEvent_13, _projectMessagesListener_14, _diagramClientErrorHandler_15, _translationService_16, _xmlEditorView_17, _projectDiagramResourceServiceCaller_18, _sessionManager_19, _sessionCommandManager_20, _decisionNavigatorDock_21, _layoutHelper_22, _dataTypesPage_23, _openDiagramLayoutExecutor_24, _includedModelsPage_25, _importsPageProvider_26, _editorSearchIndex_27, _searchBarComponent_28);
    registerDependentScopedReference(instance, _savePopUpPresenter_5);
    registerDependentScopedReference(instance, _editorSessionPresenterInstances_8);
    registerDependentScopedReference(instance, _xmlEditorView_17);
    registerDependentScopedReference(instance, _refreshFormPropertiesEvent_13);
    registerDependentScopedReference(instance, _projectDiagramServices_7);
    registerDependentScopedReference(instance, _changeTitleNotificationEvent_4);
    registerDependentScopedReference(instance, _includedModelsPage_25);
    registerDependentScopedReference(instance, _onDiagramFocusEvent_11);
    registerDependentScopedReference(instance, _menuSessionItems_10);
    registerDependentScopedReference(instance, _viewerSessionPresenterInstances_9);
    registerDependentScopedReference(instance, _diagramClientErrorHandler_15);
    registerDependentScopedReference(instance, _editorSearchIndex_27);
    registerDependentScopedReference(instance, _layoutHelper_22);
    registerDependentScopedReference(instance, _openDiagramLayoutExecutor_24);
    registerDependentScopedReference(instance, _onDiagramLostFocusEvent_12);
    registerDependentScopedReference(instance, _dataTypesPage_23);
    registerDependentScopedReference(instance, _documentationView_1);
    registerDependentScopedReference(instance, _projectDiagramResourceServiceCaller_18);
    registerDependentScopedReference(instance, _projectMessagesListener_14);
    registerDependentScopedReference(instance, _view_0);
    registerDependentScopedReference(instance, _searchBarComponent_28);
    setIncompleteInstance(instance);
    final Event BaseEditor_changeTitleNotification = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ChangeTitleWidgetEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_changeTitleNotification);
    BaseEditor_Event_changeTitleNotification(instance, BaseEditor_changeTitleNotification);
    final BasicFileMenuBuilderImpl BaseEditor_menuBuilder = (BasicFileMenuBuilderImpl) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_BasicFileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_menuBuilder);
    BaseEditor_BasicFileMenuBuilder_menuBuilder(instance, BaseEditor_menuBuilder);
    final SaveAndRenameCommandBuilder BaseEditor_saveAndRenameCommandBuilder = (SaveAndRenameCommandBuilder) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_c_SaveAndRenameCommandBuilder__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_saveAndRenameCommandBuilder);
    BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(instance, BaseEditor_saveAndRenameCommandBuilder);
    final DownloadMenuItemBuilder BaseEditor_downloadMenuItemBuilder = (DownloadMenuItemBuilder) contextManager.getInstance("Type_factory__o_u_e_e_c_c_m_DownloadMenuItemBuilder__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_downloadMenuItemBuilder);
    BaseEditor_DownloadMenuItemBuilder_downloadMenuItemBuilder(instance, BaseEditor_downloadMenuItemBuilder);
    final DeletePopUpPresenter BaseEditor_deletePopUpPresenter = (DeletePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_DeletePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    BaseEditor_DeletePopUpPresenter_deletePopUpPresenter(instance, BaseEditor_deletePopUpPresenter);
    final ProjectController KieEditor_projectController = (ProjectController) contextManager.getInstance("Type_factory__o_g_c_s_p_c_s_ProjectController__quals__j_e_i_Any_j_e_i_Default");
    KieEditor_ProjectController_projectController(instance, KieEditor_projectController);
    final Event BaseEditor_concurrentDeleteIgnoredEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentDeleteIgnoredEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentDeleteIgnoredEvent);
    BaseEditor_Event_concurrentDeleteIgnoredEvent(instance, BaseEditor_concurrentDeleteIgnoredEvent);
    final AlertsButtonMenuItemBuilder KieEditor_alertsButtonMenuItemBuilder = (AlertsButtonMenuItemBuilder) contextManager.getInstance("Type_factory__o_g_m_c_c_w_b_AlertsButtonMenuItemBuilder__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_alertsButtonMenuItemBuilder);
    KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(instance, KieEditor_alertsButtonMenuItemBuilder);
    final RenamePopUpPresenter KieEditor_renamePopUpPresenter = (RenamePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_RenamePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_renamePopUpPresenter);
    KieEditor_RenamePopUpPresenter_renamePopUpPresenter(instance, KieEditor_renamePopUpPresenter);
    final ManagedInstance BaseEditor_menuBuilderManagedInstance = (ManagedInstance) contextManager.getContextualInstance("ContextualProvider_factory__o_j_e_i_c_a_ManagedInstance__quals__Universal", new Class[] { BasicFileMenuBuilder.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_menuBuilderManagedInstance);
    BaseEditor_ManagedInstance_menuBuilderManagedInstance(instance, BaseEditor_menuBuilderManagedInstance);
    final Promises BaseEditor_promises = (Promises) contextManager.getInstance("Type_factory__o_u_c_p_Promises__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_promises);
    BaseEditor_Promises_promises(instance, BaseEditor_promises);
    final KieEditorWrapperViewImpl KieEditor_kieView = (KieEditorWrapperViewImpl) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_KieEditorWrapperViewImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_kieView);
    KieEditor_KieEditorWrapperView_kieView(instance, KieEditor_kieView);
    final PlaceManagerImpl BaseEditor_placeManager = (PlaceManagerImpl) contextManager.getInstance("Type_factory__o_u_c_m_PlaceManagerImpl__quals__j_e_i_Any_j_e_i_Default");
    BaseEditor_PlaceManager_placeManager(instance, BaseEditor_placeManager);
    final WorkspaceProjectContext KieEditor_workbenchContext = (WorkspaceProjectContext) contextManager.getInstance("Type_factory__o_g_c_s_p_c_c_WorkspaceProjectContext__quals__j_e_i_Any_j_e_i_Default");
    KieEditor_WorkspaceProjectContext_workbenchContext(instance, KieEditor_workbenchContext);
    final Event BaseEditor_concurrentRenameIgnoredEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentRenameIgnoredEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentRenameIgnoredEvent);
    BaseEditor_Event_concurrentRenameIgnoredEvent(instance, BaseEditor_concurrentRenameIgnoredEvent);
    final PerspectiveManagerImpl KieEditor_perspectiveManager = (PerspectiveManagerImpl) contextManager.getInstance("Type_factory__o_u_c_m_PerspectiveManagerImpl__quals__j_e_i_Any_j_e_i_Default");
    KieEditor_PerspectiveManager_perspectiveManager(instance, KieEditor_perspectiveManager);
    final FileMenuBuilderImpl KieEditor_fileMenuBuilder = (FileMenuBuilderImpl) contextManager.getInstance("Type_factory__o_k_w_c_w_c_m_FileMenuBuilderImpl__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_fileMenuBuilder);
    KieEditor_FileMenuBuilder_fileMenuBuilder(instance, KieEditor_fileMenuBuilder);
    final Event BaseEditor_concurrentRenameAcceptedEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentRenameAcceptedEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentRenameAcceptedEvent);
    BaseEditor_Event_concurrentRenameAcceptedEvent(instance, BaseEditor_concurrentRenameAcceptedEvent);
    final CopyPopUpPresenter KieEditor_copyPopUpPresenter = (CopyPopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_CopyPopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_copyPopUpPresenter);
    KieEditor_CopyPopUpPresenter_copyPopUpPresenter(instance, KieEditor_copyPopUpPresenter);
    final DefaultEditorDock KieEditor_docks = (DefaultEditorDock) contextManager.getInstance("Type_factory__o_k_w_c_w_c_d_DefaultEditorDock__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_docks);
    KieEditor_DefaultEditorDock_docks(instance, KieEditor_docks);
    final VersionRecordManager BaseEditor_versionRecordManager = (VersionRecordManager) contextManager.getInstance("Type_factory__o_u_e_e_c_c_h_VersionRecordManager__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, BaseEditor_versionRecordManager);
    BaseEditor_VersionRecordManager_versionRecordManager(instance, BaseEditor_versionRecordManager);
    final Event BaseEditor_concurrentDeleteAcceptedEvent = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { ConcurrentDeleteAcceptedEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_concurrentDeleteAcceptedEvent);
    BaseEditor_Event_concurrentDeleteAcceptedEvent(instance, BaseEditor_concurrentDeleteAcceptedEvent);
    final DefaultFileNameValidator BaseEditor_fileNameValidator = (DefaultFileNameValidator) contextManager.getInstance("Type_factory__o_u_e_e_c_c_v_DefaultFileNameValidator__quals__j_e_i_Any_j_e_i_Default");
    BaseEditor_DefaultFileNameValidator_fileNameValidator(instance, BaseEditor_fileNameValidator);
    final Event BaseEditor_notification = (Event) contextManager.getContextualInstance("ContextualProvider_factory__j_e_e_Event__quals__Universal", new Class[] { NotificationEvent.class }, new Annotation[] { });
    registerDependentScopedReference(instance, BaseEditor_notification);
    BaseEditor_Event_notification(instance, BaseEditor_notification);
    final SavePopUpPresenter KieEditor_savePopUpPresenter = (SavePopUpPresenter) contextManager.getInstance("Type_factory__o_u_e_e_c_c_f_p_SavePopUpPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_savePopUpPresenter);
    KieEditor_SavePopUpPresenter_savePopUpPresenter(instance, KieEditor_savePopUpPresenter);
    final OverviewWidgetPresenter KieEditor_overviewWidget = (OverviewWidgetPresenter) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_w_OverviewWidgetPresenter__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_overviewWidget);
    KieEditor_OverviewWidgetPresenter_overviewWidget(instance, KieEditor_overviewWidget);
    final AssetUpdateValidator KieEditor_assetUpdateValidator = (AssetUpdateValidator) contextManager.getInstance("Type_factory__o_k_w_c_w_m_c_v_AssetUpdateValidator__quals__j_e_i_Any_j_e_i_Default");
    registerDependentScopedReference(instance, KieEditor_assetUpdateValidator);
    KieEditor_AssetUpdateValidator_assetUpdateValidator(instance, KieEditor_assetUpdateValidator);
    thisInstance.setReference(instance, "onMultiPageEditorSelectedPageEventSubscription", CDI.subscribeLocal("org.uberfire.client.views.pfly.multipage.MultiPageEditorSelectedPageEvent", new AbstractCDIEventCallback<MultiPageEditorSelectedPageEvent>() {
      public void fireEvent(final MultiPageEditorSelectedPageEvent event) {
        instance.onMultiPageEditorSelectedPageEvent(event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.views.pfly.multipage.MultiPageEditorSelectedPageEvent []";
      }
    }));
    thisInstance.setReference(instance, "onRefreshFormPropertiesEventSubscription", CDI.subscribeLocal("org.kie.workbench.common.stunner.forms.client.event.RefreshFormPropertiesEvent", new AbstractCDIEventCallback<RefreshFormPropertiesEvent>() {
      public void fireEvent(final RefreshFormPropertiesEvent event) {
        instance.onRefreshFormPropertiesEvent(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.stunner.forms.client.event.RefreshFormPropertiesEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataTypePageNavTabActiveEventSubscription", CDI.subscribeLocal("org.kie.workbench.common.dmn.client.editors.types.DataTypePageTabActiveEvent", new AbstractCDIEventCallback<DataTypePageTabActiveEvent>() {
      public void fireEvent(final DataTypePageTabActiveEvent event) {
        instance.onDataTypePageNavTabActiveEvent(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.dmn.client.editors.types.DataTypePageTabActiveEvent []";
      }
    }));
    thisInstance.setReference(instance, "onDataTypeEditModeToggleSubscription", CDI.subscribeLocal("org.kie.workbench.common.dmn.client.editors.types.listview.common.DataTypeEditModeToggleEvent", new AbstractCDIEventCallback<DataTypeEditModeToggleEvent>() {
      public void fireEvent(final DataTypeEditModeToggleEvent event) {
        instance.onDataTypeEditModeToggle(event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.dmn.client.editors.types.listview.common.DataTypeEditModeToggleEvent []";
      }
    }));
    thisInstance.setReference(instance, "onEditExpressionEventSubscription", CDI.subscribeLocal("org.kie.workbench.common.dmn.client.events.EditExpressionEvent", new AbstractCDIEventCallback<EditExpressionEvent>() {
      public void fireEvent(final EditExpressionEvent event) {
        DMNDiagramEditor_onEditExpressionEvent_EditExpressionEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.dmn.client.events.EditExpressionEvent []";
      }
    }));
    thisInstance.setReference(instance, "onSessionErrorEventSubscription", CDI.subscribeLocal("org.kie.workbench.common.stunner.core.client.session.event.OnSessionErrorEvent", new AbstractCDIEventCallback<OnSessionErrorEvent>() {
      public void fireEvent(final OnSessionErrorEvent event) {
        AbstractProjectDiagramEditor_onSessionErrorEvent_OnSessionErrorEvent(instance, event);
      }
      public String toString() {
        return "Observer: org.kie.workbench.common.stunner.core.client.session.event.OnSessionErrorEvent []";
      }
    }));
    thisInstance.setReference(instance, "onShowDiagramEditorDocksSubscription", CDI.subscribeLocal("org.uberfire.client.workbench.events.PlaceGainFocusEvent", new AbstractCDIEventCallback<PlaceGainFocusEvent>() {
      public void fireEvent(final PlaceGainFocusEvent event) {
        instance.onShowDiagramEditorDocks(event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.workbench.events.PlaceGainFocusEvent []";
      }
    }));
    thisInstance.setReference(instance, "onHideDocksSubscription", CDI.subscribeLocal("org.uberfire.client.workbench.events.PlaceHiddenEvent", new AbstractCDIEventCallback<PlaceHiddenEvent>() {
      public void fireEvent(final PlaceHiddenEvent event) {
        instance.onHideDocks(event);
      }
      public String toString() {
        return "Observer: org.uberfire.client.workbench.events.PlaceHiddenEvent []";
      }
    }));
    thisInstance.setReference(instance, "onRepositoryRemovedSubscription", CDI.subscribe("org.guvnor.structure.repositories.RepositoryRemovedEvent", new AbstractCDIEventCallback<RepositoryRemovedEvent>() {
      public void fireEvent(final RepositoryRemovedEvent event) {
        instance.onRepositoryRemoved(event);
      }
      public String toString() {
        return "Observer: org.guvnor.structure.repositories.RepositoryRemovedEvent []";
      }
    }));
    thisInstance.setReference(instance, "onRepositoryRemovedSubscriptionForRepositoryRemovedEvent", ErraiBus.get().subscribe("cdi.event:org.guvnor.structure.repositories.RepositoryRemovedEvent", CDI.ROUTING_CALLBACK));
    thisInstance.setReference(instance, "onRestoreSubscription", CDI.subscribeLocal("org.uberfire.ext.editor.commons.version.events.RestoreEvent", new AbstractCDIEventCallback<RestoreEvent>() {
      public void fireEvent(final RestoreEvent event) {
        instance.onRestore(event);
      }
      public String toString() {
        return "Observer: org.uberfire.ext.editor.commons.version.events.RestoreEvent []";
      }
    }));
    setIncompleteInstance(null);
    return instance;
  }

  public void generatedDestroyInstance(final Object instance, final ContextManager contextManager) {
    destroyInstanceHelper((DMNDiagramEditor) instance, contextManager);
  }

  public void destroyInstanceHelper(final DMNDiagramEditor instance, final ContextManager contextManager) {
    ((Subscription) thisInstance.getReferenceAs(instance, "onMultiPageEditorSelectedPageEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRefreshFormPropertiesEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataTypePageNavTabActiveEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onDataTypeEditModeToggleSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onEditExpressionEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onSessionErrorEventSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onShowDiagramEditorDocksSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onHideDocksSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRepositoryRemovedSubscription", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRepositoryRemovedSubscriptionForRepositoryRemovedEvent", Subscription.class)).remove();
    ((Subscription) thisInstance.getReferenceAs(instance, "onRestoreSubscription", Subscription.class)).remove();
  }

  public void invokePostConstructs(final DMNDiagramEditor instance) {
    instance.init();
    instance.init();
  }

  native static WorkspaceProjectContext KieEditor_WorkspaceProjectContext_workbenchContext(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::workbenchContext;
  }-*/;

  native static void KieEditor_WorkspaceProjectContext_workbenchContext(KieEditor instance, WorkspaceProjectContext value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::workbenchContext = value;
  }-*/;

  native static PlaceManager BaseEditor_PlaceManager_placeManager(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::placeManager;
  }-*/;

  native static void BaseEditor_PlaceManager_placeManager(BaseEditor instance, PlaceManager value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::placeManager = value;
  }-*/;

  native static RenamePopUpPresenter KieEditor_RenamePopUpPresenter_renamePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::renamePopUpPresenter;
  }-*/;

  native static void KieEditor_RenamePopUpPresenter_renamePopUpPresenter(KieEditor instance, RenamePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::renamePopUpPresenter = value;
  }-*/;

  native static PerspectiveManager KieEditor_PerspectiveManager_perspectiveManager(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::perspectiveManager;
  }-*/;

  native static void KieEditor_PerspectiveManager_perspectiveManager(KieEditor instance, PerspectiveManager value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::perspectiveManager = value;
  }-*/;

  native static DefaultEditorDock KieEditor_DefaultEditorDock_docks(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::docks;
  }-*/;

  native static void KieEditor_DefaultEditorDock_docks(KieEditor instance, DefaultEditorDock value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::docks = value;
  }-*/;

  native static ManagedInstance BaseEditor_ManagedInstance_menuBuilderManagedInstance(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilderManagedInstance;
  }-*/;

  native static void BaseEditor_ManagedInstance_menuBuilderManagedInstance(BaseEditor instance, ManagedInstance<BasicFileMenuBuilder> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilderManagedInstance = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentRenameIgnoredEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameIgnoredEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentRenameIgnoredEvent(BaseEditor instance, Event<ConcurrentRenameIgnoredEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameIgnoredEvent = value;
  }-*/;

  native static DefaultFileNameValidator BaseEditor_DefaultFileNameValidator_fileNameValidator(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::fileNameValidator;
  }-*/;

  native static void BaseEditor_DefaultFileNameValidator_fileNameValidator(BaseEditor instance, DefaultFileNameValidator value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::fileNameValidator = value;
  }-*/;

  native static SavePopUpPresenter KieEditor_SavePopUpPresenter_savePopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::savePopUpPresenter;
  }-*/;

  native static void KieEditor_SavePopUpPresenter_savePopUpPresenter(KieEditor instance, SavePopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::savePopUpPresenter = value;
  }-*/;

  native static Event BaseEditor_Event_changeTitleNotification(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::changeTitleNotification;
  }-*/;

  native static void BaseEditor_Event_changeTitleNotification(BaseEditor instance, Event<ChangeTitleWidgetEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::changeTitleNotification = value;
  }-*/;

  native static Promises BaseEditor_Promises_promises(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::promises;
  }-*/;

  native static void BaseEditor_Promises_promises(BaseEditor instance, Promises value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::promises = value;
  }-*/;

  native static ProjectController KieEditor_ProjectController_projectController(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::projectController;
  }-*/;

  native static void KieEditor_ProjectController_projectController(KieEditor instance, ProjectController value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::projectController = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentDeleteAcceptedEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteAcceptedEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentDeleteAcceptedEvent(BaseEditor instance, Event<ConcurrentDeleteAcceptedEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteAcceptedEvent = value;
  }-*/;

  native static Event BaseEditor_Event_notification(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::notification;
  }-*/;

  native static void BaseEditor_Event_notification(BaseEditor instance, Event<NotificationEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::notification = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentDeleteIgnoredEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteIgnoredEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentDeleteIgnoredEvent(BaseEditor instance, Event<ConcurrentDeleteIgnoredEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentDeleteIgnoredEvent = value;
  }-*/;

  native static BasicFileMenuBuilder BaseEditor_BasicFileMenuBuilder_menuBuilder(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilder;
  }-*/;

  native static void BaseEditor_BasicFileMenuBuilder_menuBuilder(BaseEditor instance, BasicFileMenuBuilder value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::menuBuilder = value;
  }-*/;

  native static SaveAndRenameCommandBuilder BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::saveAndRenameCommandBuilder;
  }-*/;

  native static void BaseEditor_SaveAndRenameCommandBuilder_saveAndRenameCommandBuilder(BaseEditor instance, SaveAndRenameCommandBuilder<ProjectDiagramResource, Metadata> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::saveAndRenameCommandBuilder = value;
  }-*/;

  native static DeletePopUpPresenter BaseEditor_DeletePopUpPresenter_deletePopUpPresenter(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::deletePopUpPresenter;
  }-*/;

  native static void BaseEditor_DeletePopUpPresenter_deletePopUpPresenter(BaseEditor instance, DeletePopUpPresenter value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::deletePopUpPresenter = value;
  }-*/;

  native static AssetUpdateValidator KieEditor_AssetUpdateValidator_assetUpdateValidator(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::assetUpdateValidator;
  }-*/;

  native static void KieEditor_AssetUpdateValidator_assetUpdateValidator(KieEditor instance, AssetUpdateValidator value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::assetUpdateValidator = value;
  }-*/;

  native static AlertsButtonMenuItemBuilder KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::alertsButtonMenuItemBuilder;
  }-*/;

  native static void KieEditor_AlertsButtonMenuItemBuilder_alertsButtonMenuItemBuilder(KieEditor instance, AlertsButtonMenuItemBuilder value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::alertsButtonMenuItemBuilder = value;
  }-*/;

  native static CopyPopUpPresenter KieEditor_CopyPopUpPresenter_copyPopUpPresenter(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::copyPopUpPresenter;
  }-*/;

  native static void KieEditor_CopyPopUpPresenter_copyPopUpPresenter(KieEditor instance, CopyPopUpPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::copyPopUpPresenter = value;
  }-*/;

  native static OverviewWidgetPresenter KieEditor_OverviewWidgetPresenter_overviewWidget(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::overviewWidget;
  }-*/;

  native static void KieEditor_OverviewWidgetPresenter_overviewWidget(KieEditor instance, OverviewWidgetPresenter value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::overviewWidget = value;
  }-*/;

  native static KieEditorWrapperView KieEditor_KieEditorWrapperView_kieView(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::kieView;
  }-*/;

  native static void KieEditor_KieEditorWrapperView_kieView(KieEditor instance, KieEditorWrapperView value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::kieView = value;
  }-*/;

  native static DownloadMenuItemBuilder BaseEditor_DownloadMenuItemBuilder_downloadMenuItemBuilder(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::downloadMenuItemBuilder;
  }-*/;

  native static void BaseEditor_DownloadMenuItemBuilder_downloadMenuItemBuilder(BaseEditor instance, DownloadMenuItemBuilder value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::downloadMenuItemBuilder = value;
  }-*/;

  native static VersionRecordManager BaseEditor_VersionRecordManager_versionRecordManager(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::versionRecordManager;
  }-*/;

  native static void BaseEditor_VersionRecordManager_versionRecordManager(BaseEditor instance, VersionRecordManager value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::versionRecordManager = value;
  }-*/;

  native static FileMenuBuilder KieEditor_FileMenuBuilder_fileMenuBuilder(KieEditor instance) /*-{
    return instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::fileMenuBuilder;
  }-*/;

  native static void KieEditor_FileMenuBuilder_fileMenuBuilder(KieEditor instance, FileMenuBuilder value) /*-{
    instance.@org.kie.workbench.common.widgets.metadata.client.KieEditor::fileMenuBuilder = value;
  }-*/;

  native static Event BaseEditor_Event_concurrentRenameAcceptedEvent(BaseEditor instance) /*-{
    return instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameAcceptedEvent;
  }-*/;

  native static void BaseEditor_Event_concurrentRenameAcceptedEvent(BaseEditor instance, Event<ConcurrentRenameAcceptedEvent> value) /*-{
    instance.@org.uberfire.ext.editor.commons.client.BaseEditor::concurrentRenameAcceptedEvent = value;
  }-*/;

  public native static void AbstractProjectDiagramEditor_onSessionErrorEvent_OnSessionErrorEvent(AbstractProjectDiagramEditor instance, OnSessionErrorEvent a0) /*-{
    instance.@org.kie.workbench.common.stunner.project.client.editor.AbstractProjectDiagramEditor::onSessionErrorEvent(Lorg/kie/workbench/common/stunner/core/client/session/event/OnSessionErrorEvent;)(a0);
  }-*/;

  public native static void DMNDiagramEditor_onEditExpressionEvent_EditExpressionEvent(DMNDiagramEditor instance, EditExpressionEvent a0) /*-{
    instance.@org.kie.workbench.common.dmn.project.client.editor.DMNDiagramEditor::onEditExpressionEvent(Lorg/kie/workbench/common/dmn/client/events/EditExpressionEvent;)(a0);
  }-*/;
}