package org.jboss.errai.marshalling.client.api;

import java.util.Date;
import java.util.Set;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jbpm.workbench.es.model.RequestSummary;
import org.jbpm.workbench.es.util.RequestStatus;

public class Marshaller_o_j_w_e_m_RequestSummary_1_Impl implements GeneratedMarshaller<RequestSummary> {
  private RequestSummary[] EMPTY_ARRAY = new RequestSummary[0];
  private Marshaller<Long> java_lang_Long = Marshalling.getMarshaller(Long.class);
  private Marshaller<Date> java_util_Date = Marshalling.getMarshaller(Date.class);
  private Marshaller<RequestStatus> org_jbpm_workbench_es_util_RequestStatus = null;
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller<Integer> java_lang_Integer = Marshalling.getMarshaller(Integer.class);
  public RequestSummary[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  public RequestSummary demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(RequestSummary.class, objId);
    }
    RequestSummary entity = new RequestSummary();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "jobId": entity.setJobId(java_lang_Long.demarshall(objVal, a1));
        break;
        case "time": entity.setTime(java_util_Date.demarshall(objVal, a1));
        break;
        case "status": entity.setStatus(objVal.isObject() != null ? Enum.valueOf(RequestStatus.class, objVal.isObject().get("^EnumStringValue").isString().stringValue()) : objVal.isString() != null ? Enum.valueOf(RequestStatus.class, objVal.isString().stringValue()) : null);
        break;
        case "commandName": entity.setCommandName(java_lang_String.demarshall(objVal, a1));
        break;
        case "message": entity.setMessage(java_lang_String.demarshall(objVal, a1));
        break;
        case "key": entity.setKey(java_lang_String.demarshall(objVal, a1));
        break;
        case "retries": entity.setRetries(java_lang_Integer.demarshall(objVal, a1));
        break;
        case "executions": entity.setExecutions(java_lang_Integer.demarshall(objVal, a1));
        break;
        case "processName": entity.setProcessName(java_lang_String.demarshall(objVal, a1));
        break;
        case "processInstanceId": entity.setProcessInstanceId(java_lang_Long.demarshall(objVal, a1));
        break;
        case "processInstanceDescription": entity.setProcessInstanceDescription(java_lang_String.demarshall(objVal, a1));
        break;
        case "deploymentId": entity.setDeploymentId(java_lang_String.demarshall(objVal, a1));
        break;
        case "id": entity.setId(java_lang_Long.demarshall(objVal, a1));
        break;
        case "name": entity.setName(java_lang_String.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(RequestSummary a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.jbpm.workbench.es.model.RequestSummary") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((((((((((((((((((((((((((((((((((((((("" + ",\"") + "jobId") + "\":") + java_lang_Long.marshall(a0.getJobId(), a1)) + ",\"") + "time") + "\":") + java_util_Date.marshall(a0.getTime(), a1)) + ",\"") + "status") + "\":") + (a0.getStatus() != null ? ((((((("{\"" + "^EncodedType") + "\":\"") + "org.jbpm.workbench.es.util.RequestStatus") + "\",\"") + "^EnumStringValue") + "\":\"") + a0.getStatus().name()) + "\"}" : "null")) + ",\"") + "commandName") + "\":") + java_lang_String.marshall(a0.getCommandName(), a1)) + ",\"") + "message") + "\":") + java_lang_String.marshall(a0.getMessage(), a1)) + ",\"") + "key") + "\":") + java_lang_String.marshall(a0.getKey(), a1)) + ",\"") + "retries") + "\":") + java_lang_Integer.marshall(a0.getRetries(), a1)) + ",\"") + "executions") + "\":") + java_lang_Integer.marshall(a0.getExecutions(), a1)) + ",\"") + "processName") + "\":") + java_lang_String.marshall(a0.getProcessName(), a1)) + ",\"") + "processInstanceId") + "\":") + java_lang_Long.marshall(a0.getProcessInstanceId(), a1)) + ",\"") + "processInstanceDescription") + "\":") + java_lang_String.marshall(a0.getProcessInstanceDescription(), a1)) + ",\"") + "deploymentId") + "\":") + java_lang_String.marshall(a0.getDeploymentId(), a1)) + ",\"") + "id") + "\":") + java_lang_Long.marshall(a0.getId(), a1)) + ",\"") + "name") + "\":") + java_lang_String.marshall(a0.getName(), a1)) + "}");
  }

  private void lazyInit() {
    if (org_jbpm_workbench_es_util_RequestStatus == null) {
      org_jbpm_workbench_es_util_RequestStatus = Marshalling.getMarshaller(RequestStatus.class);
    }
  }
}