package org.jboss.errai.marshalling.client.api;

import java.util.Collection;
import java.util.Map;
import java.util.Set;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.jbpm.workbench.pr.model.ProcessSummary;

public class Marshaller_o_j_w_p_m_ProcessSummary_1_Impl implements GeneratedMarshaller<ProcessSummary> {
  private ProcessSummary[] EMPTY_ARRAY = new ProcessSummary[0];
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller<Boolean> java_lang_Boolean = Marshalling.getMarshaller(Boolean.class);
  private Marshaller<Map> java_util_Map = Marshalling.getMarshaller(Map.class);
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  public ProcessSummary[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static boolean ProcessSummary_boolean_dynamic(ProcessSummary instance) /*-{
    return instance.@org.jbpm.workbench.pr.model.ProcessSummary::dynamic;
  }-*/;

  native static void ProcessSummary_boolean_dynamic(ProcessSummary instance, boolean value) /*-{
    instance.@org.jbpm.workbench.pr.model.ProcessSummary::dynamic = value;
  }-*/;

  public ProcessSummary demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(ProcessSummary.class, objId);
    }
    ProcessSummary entity = new ProcessSummary();
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "processDefId": entity.setProcessDefId(java_lang_String.demarshall(objVal, a1));
        break;
        case "processDefName": entity.setProcessDefName(java_lang_String.demarshall(objVal, a1));
        break;
        case "version": entity.setVersion(java_lang_String.demarshall(objVal, a1));
        break;
        case "deploymentId": entity.setDeploymentId(java_lang_String.demarshall(objVal, a1));
        break;
        case "dynamic": ProcessSummary_boolean_dynamic(entity, java_lang_Boolean.demarshall(objVal, a1));
        break;
        case "associatedEntities": a1.setAssumedMapKeyType("java.lang.String");
        a1.setAssumedMapValueType("[Ljava.lang.String;");
        entity.setAssociatedEntities(java_util_Map.demarshall(objVal, a1));
        a1.resetAssumedTypes();
        break;
        case "serviceTasks": a1.setAssumedMapKeyType("java.lang.String");
        a1.setAssumedMapValueType("java.lang.String");
        entity.setServiceTasks(java_util_Map.demarshall(objVal, a1));
        a1.resetAssumedTypes();
        break;
        case "processVariables": a1.setAssumedMapKeyType("java.lang.String");
        a1.setAssumedMapValueType("java.lang.String");
        entity.setProcessVariables(java_util_Map.demarshall(objVal, a1));
        a1.resetAssumedTypes();
        break;
        case "reusableSubProcesses": entity.setReusableSubProcesses((Collection) ((ObjectMarshaller) java_lang_Object).demarshall(Collection.class, objVal, a1));
        break;
        case "dynamicFormsEnabled": entity.setDynamicFormsEnabled(java_lang_Boolean.demarshall(objVal, a1));
        break;
        case "nodes": entity.setNodes((Collection) ((ObjectMarshaller) java_lang_Object).demarshall(Collection.class, objVal, a1));
        break;
        case "timers": entity.setTimers((Collection) ((ObjectMarshaller) java_lang_Object).demarshall(Collection.class, objVal, a1));
        break;
        case "id": entity.setId(java_lang_String.demarshall(objVal, a1));
        break;
        case "name": entity.setName(java_lang_String.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  native static boolean ProcessSummary_boolean_dynamicFormsEnabled(ProcessSummary instance) /*-{
    return instance.@org.jbpm.workbench.pr.model.ProcessSummary::dynamicFormsEnabled;
  }-*/;

  native static void ProcessSummary_boolean_dynamicFormsEnabled(ProcessSummary instance, boolean value) /*-{
    instance.@org.jbpm.workbench.pr.model.ProcessSummary::dynamicFormsEnabled = value;
  }-*/;

  public String marshall(ProcessSummary a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.jbpm.workbench.pr.model.ProcessSummary") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((((((((((((((((((((((((((((((((((((((("" + ",\"") + "processDefId") + "\":") + java_lang_String.marshall(a0.getProcessDefId(), a1)) + ",\"") + "processDefName") + "\":") + java_lang_String.marshall(a0.getProcessDefName(), a1)) + ",\"") + "version") + "\":") + java_lang_String.marshall(a0.getVersion(), a1)) + ",\"") + "deploymentId") + "\":") + java_lang_String.marshall(a0.getDeploymentId(), a1)) + ",\"") + "dynamic") + "\":") + java_lang_Boolean.marshall(ProcessSummary_boolean_dynamic(a0), a1)) + ",\"") + "associatedEntities") + "\":") + java_util_Map.marshall(a0.getAssociatedEntities(), a1)) + ",\"") + "serviceTasks") + "\":") + java_util_Map.marshall(a0.getServiceTasks(), a1)) + ",\"") + "processVariables") + "\":") + java_util_Map.marshall(a0.getProcessVariables(), a1)) + ",\"") + "reusableSubProcesses") + "\":") + java_lang_Object.marshall(a0.getReusableSubProcesses(), a1)) + ",\"") + "dynamicFormsEnabled") + "\":") + java_lang_Boolean.marshall(ProcessSummary_boolean_dynamicFormsEnabled(a0), a1)) + ",\"") + "nodes") + "\":") + java_lang_Object.marshall(a0.getNodes(), a1)) + ",\"") + "timers") + "\":") + java_lang_Object.marshall(a0.getTimers(), a1)) + ",\"") + "id") + "\":") + java_lang_String.marshall(a0.getId(), a1)) + ",\"") + "name") + "\":") + java_lang_String.marshall(a0.getName(), a1)) + "}");
  }

  private void lazyInit() {

  }
}