package org.jboss.errai.marshalling.client.api;

import java.util.List;
import java.util.Set;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;
import org.jboss.errai.marshalling.client.marshallers.ObjectMarshaller;
import org.kie.workbench.common.stunner.core.command.Command;
import org.kie.workbench.common.stunner.core.command.impl.AbstractCompositeCommand;
import org.kie.workbench.common.stunner.core.graph.Node;
import org.kie.workbench.common.stunner.core.graph.command.GraphCommandExecutionContext;
import org.kie.workbench.common.stunner.core.graph.command.impl.AddChildNodeCommand;
import org.kie.workbench.common.stunner.core.graph.content.view.Point2D;
import org.kie.workbench.common.stunner.core.rule.RuleViolation;

public class Marshaller_o_k_w_c_s_c_g_c_i_AddChildNodeCommand_1_Impl implements GeneratedMarshaller<AddChildNodeCommand> {
  private AddChildNodeCommand[] EMPTY_ARRAY = new AddChildNodeCommand[0];
  private Marshaller<String> java_lang_String = Marshalling.getMarshaller(String.class);
  private Marshaller java_lang_Object = Marshalling.getMarshaller(Object.class);
  private Marshaller<Point2D> org_kie_workbench_common_stunner_core_graph_content_view_Point2D = null;
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  private Marshaller<Boolean> java_lang_Boolean = Marshalling.getMarshaller(Boolean.class);
  public AddChildNodeCommand[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  native static String AddChildNodeCommand_String_parentUUID(AddChildNodeCommand instance) /*-{
    return instance.@org.kie.workbench.common.stunner.core.graph.command.impl.AddChildNodeCommand::parentUUID;
  }-*/;

  native static void AddChildNodeCommand_String_parentUUID(AddChildNodeCommand instance, String value) /*-{
    instance.@org.kie.workbench.common.stunner.core.graph.command.impl.AddChildNodeCommand::parentUUID = value;
  }-*/;

  native static List AbstractCompositeCommand_List_commands(AbstractCompositeCommand instance) /*-{
    return instance.@org.kie.workbench.common.stunner.core.command.impl.AbstractCompositeCommand::commands;
  }-*/;

  native static void AbstractCompositeCommand_List_commands(AbstractCompositeCommand instance, List<Command<GraphCommandExecutionContext, RuleViolation>> value) /*-{
    instance.@org.kie.workbench.common.stunner.core.command.impl.AbstractCompositeCommand::commands = value;
  }-*/;

  native static boolean AbstractCompositeCommand_boolean_initialized(AbstractCompositeCommand instance) /*-{
    return instance.@org.kie.workbench.common.stunner.core.command.impl.AbstractCompositeCommand::initialized;
  }-*/;

  native static void AbstractCompositeCommand_boolean_initialized(AbstractCompositeCommand instance, boolean value) /*-{
    instance.@org.kie.workbench.common.stunner.core.command.impl.AbstractCompositeCommand::initialized = value;
  }-*/;

  public AddChildNodeCommand demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(AddChildNodeCommand.class, objId);
    }
    final String c0 = java_lang_String.demarshall(obj.get("parentUUID"), a1);
    final Node c1 = (Node) ((ObjectMarshaller) java_lang_Object).demarshall(Node.class, obj.get("candidate"), a1);
    final Point2D c2 = org_kie_workbench_common_stunner_core_graph_content_view_Point2D.demarshall(obj.get("location"), a1);
    AddChildNodeCommand entity = new AddChildNodeCommand(c0, c1, c2);
    a1.recordObject(objId, entity);
    final Set<String> keys = obj.keySet();
    for (String key : keys) {
      if (key.equals("^EncodedType") || key.equals("^ObjectID")) {
        continue;
      }
      EJValue objVal = obj.getIfNotNull(key);
      if (objVal == null) {
        continue;
      }
      switch (key) {
        case "parentUUID": AddChildNodeCommand_String_parentUUID(entity, java_lang_String.demarshall(objVal, a1));
        break;
        case "commands": a1.setAssumedElementType("org.kie.workbench.common.stunner.core.command.Command");
        AbstractCompositeCommand_List_commands(entity, java_util_List.demarshall(objVal, a1));
        break;
        case "initialized": AbstractCompositeCommand_boolean_initialized(entity, java_lang_Boolean.demarshall(objVal, a1));
        break;
      }
    }
    return entity;
  }

  public String marshall(AddChildNodeCommand a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final String prefix = ((((((((("" + "{\"") + "^EncodedType") + "\":\"") + "org.kie.workbench.common.stunner.core.graph.command.impl.AddChildNodeCommand") + "\"") + ",\"") + "^ObjectID") + "\":\"") + a1.getObject(a0)) + "\"";
    if (ref) {
      return prefix + "}";
    }
    return prefix + ((((((((((((((((((((("" + ",\"") + "parentUUID") + "\":") + java_lang_String.marshall(AddChildNodeCommand_String_parentUUID(a0), a1)) + ",\"") + "candidate") + "\":") + java_lang_Object.marshall(a0.getCandidate(), a1)) + ",\"") + "location") + "\":") + org_kie_workbench_common_stunner_core_graph_content_view_Point2D.marshall(a0.getLocation(), a1)) + ",\"") + "commands") + "\":") + java_util_List.marshall(a0.getCommands(), a1)) + ",\"") + "initialized") + "\":") + java_lang_Boolean.marshall(AbstractCompositeCommand_boolean_initialized(a0), a1)) + "}");
  }

  private void lazyInit() {
    if (org_kie_workbench_common_stunner_core_graph_content_view_Point2D == null) {
      org_kie_workbench_common_stunner_core_graph_content_view_Point2D = Marshalling.getMarshaller(Point2D.class);
    }
  }
}